Jam.define("dj",function(){
    
    var exec = function(msg,params,callback){
        Jam.exec("Player",msg,params,callback);
    }
    
	function secToString(time)
	{
		min = (time - (time % 60)) / 60;
		sec = Math.round(time % 60);

		if(min < 10) min = "0" + min;
		if(sec < 10) sec = "0" + sec;

		return min + ":" + sec;
	}
	
    var player = {
    	track : null,
    	location : 0,
        isPlaying: false,
        isWaiting: false,
		locationString: function(){
			return secToString(this.location);
		},
        togglePlay: function(){
        	exec("togglePlay");
        },
        nextTrack: function(){
        	exec("nextTrack");
        },
        changeVolume: function(volume){
        	exec("changeVolume",volume);
        },
        changeProgress: function(progress){
        	exec("changeProgress",progress);
        },
        closeWindow: function() {
        	exec("closeWindow");
        },
        minimizeWindow: function(){
        	exec("minimizeWindow");
        },
        showChannelList: function(){
        	exec("showChannelList");
        },
        getSongLength: function(){
        	if (player.track && player.track.length && +player.track.length > 0)
        		return +player.track.length;
        	else return 0;
        },
        getProgress: function(){
        	// Math.ceil
        	var length = player.getSongLength();
        	if(length) return player.location / length;
        	else return 0;	
        },
        onSongChanged: function(delegate){
            exec("onSongChanged",function(track){
                player.track = track;
                delegate.call(this,track);
            });
        },
        onArtworkChanged: function  (delegate) {
        	exec("onArtworkChanged",function(url){
        		delegate.call(this,url);
        	});
        },
		onChannelChanged: function(delegate){
			exec("onChannelChanged",function(index){
				delegate.call(this,index);
			})
		},
		onStateChanged: function(delegate){
			exec("onStateChanged", function(isPlaying,isWaiting){
				if(isPlaying != null)	player.isPlaying = isPlaying;
				if(isWaiting != null)   player.isWaiting = isWaiting;	
				delegate.call(this);s
			})
		},
		_objc_song_location_changed: function(location){
			this.location = location;
		}
        
    };
        
    Jam.player = player;
    return player;
    
});

